# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution   
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from osv import  osv
from openerp.tools.translate import _

class account_invoice_tax(osv.osv):
    _name = 'account.invoice.tax'
    _inherit = 'account.invoice.tax'


    def _get_detail_amount(self, cr, uid, tax):
        obj_currency = self.pool.get('res.currency')
        invoice = tax.invoice_id
        

        result =    {
                    'debit' : 0.0,
                    'credit' : 0.0,
                    'amount_currency' : 0.0,
                    'currency_id' : False,
                    }

        invoice_currency = invoice.currency_id
        company_currency = invoice.company_id.currency_id

        if invoice_currency.id != company_currency.id:
            result['currency_id'] = invoice_currency.id

        exchange_rate = obj_currency.compute(cr, uid, invoice_currency.id, company_currency.id, \
                1.0, context={'date' : invoice.date_invoice})
        amount_total = tax.tax_amount * exchange_rate

        if invoice.type == 'out_invoice' or invoice.type == 'in_refund':
            if amount_total > 0.0:
                result['credit'] = amount_total
                result['amount_currency'] = result['currency_id'] and tax.tax_amount or 0.0
            else:
                result['debit'] = amount_total
                result['amount_currency'] = result['currency_id'] and tax.tax_amount or 0.0
        else:
            if amount_total < 0.0:
                result['credit'] = amount_total
                result['amount_currency'] = result['currency_id'] and tax.tax_amount or 0.0
            else:
                result['debit'] = amount_total
                result['amount_currency'] = result['currency_id'] and tax.tax_amount or 0.0

        return result

    def _create_account_move_line(self, cr, uid, tax, move_id):
        obj_line = self.pool.get('account.move.line')
        obj_period = self.pool.get('account.period')

        invoice = tax.invoice_id

        period_ids = obj_period.find(cr, uid, invoice.date_invoice)
        if period_ids:
            period_id = period_ids[0]

        amount = self._get_detail_amount(cr, uid, tax)

        value = {
                'move_id' : move_id,
                'name' : tax.name,
                'date' : invoice.date_invoice,
                'date_maturity' : invoice.date_due,
                'period_id' : period_id,
                'debit' : amount['debit'],
                'credit' : amount['credit'],
                'account_id' : tax.account_id.id,
                'partner_id' : invoice.partner_id.id,
                'currency_id' : amount['currency_id'],
                'amount_currency' : amount['amount_currency'],
                }

        move_id = obj_line.create(cr, uid, value)


        return move_id




account_invoice_tax()




